Index: extensions/jiwigo-ws-api/src/main/java/fr/mael/jiwigo/transverse/session/SessionManager.java
===================================================================
--- extensions/jiwigo-ws-api/src/main/java/fr/mael/jiwigo/transverse/session/SessionManager.java	(revision 9902)
+++ extensions/jiwigo-ws-api/src/main/java/fr/mael/jiwigo/transverse/session/SessionManager.java	(revision 9919)
@@ -2,117 +2,11 @@
 
 import java.io.IOException;
-import java.io.InputStream;
 import java.io.UnsupportedEncodingException;
-import java.util.ArrayList;
-import java.util.List;
 
-import org.apache.commons.lang.StringUtils;
-import org.apache.http.HttpHost;
-import org.apache.http.HttpResponse;
-import org.apache.http.NameValuePair;
-import org.apache.http.auth.AuthScope;
-import org.apache.http.auth.UsernamePasswordCredentials;
-import org.apache.http.client.entity.UrlEncodedFormEntity;
-import org.apache.http.client.methods.HttpPost;
-import org.apache.http.conn.params.ConnRoutePNames;
-import org.apache.http.impl.client.DefaultHttpClient;
-import org.apache.http.impl.conn.tsccm.ThreadSafeClientConnManager;
-import org.apache.http.message.BasicNameValuePair;
 import org.w3c.dom.Document;
 
-import fr.mael.jiwigo.transverse.enumeration.MethodsEnum;
 import fr.mael.jiwigo.transverse.exception.ProxyAuthenticationException;
-import fr.mael.jiwigo.transverse.util.Tools;
 
-/*
- *  jiwigo-ws-api Piwigo webservice access Api
- *  Copyright (c) 2010-2011 Mael mael@le-guevel.com
- *                All Rights Reserved
- *
- *  This library is free software. It comes without any warranty, to
- *  the extent permitted by applicable law. You can redistribute it
- *  and/or modify it under the terms of the Do What The Fuck You Want
- *  To Public License, Version 2, as published by Sam Hocevar. See
- *  http://sam.zoy.org/wtfpl/COPYING for more details.
- */
-/**
-
- * @author mael
- * Gestionnaire de connexion
- */
-public class SessionManager {
-
-    /**
-     * Logger
-     */
-    public static final org.apache.commons.logging.Log LOG = org.apache.commons.logging.LogFactory
-	    .getLog(SessionManager.class);
-    /**
-     * the entered login
-     */
-    private String login;
-    /**
-     * the entered password
-     */
-    private String password;
-    /**
-     * the url of the site
-     */
-    private String url;
-    /**
-     * the http client
-     */
-    private DefaultHttpClient client;
-
-    /**
-     * defines if the user uses a proxy
-     */
-    private boolean usesProxy;
-
-    /**
-     * url of the proxy
-     */
-    private String urlProxy;
-
-    /**
-     * port of the proxy
-     */
-    private int portProxy;
-
-    /**
-     * login for the proxy
-     */
-    private String loginProxy;
-
-    /**
-     * pass for the proxy
-     */
-    private String passProxy;
-
-    /**
-     * true : an error was found for the proxy
-     */
-    private boolean proxyError;
-
-    /**
-     * Constructor
-     * @param login the login
-     * @param password the password
-     * @param url the url of the site
-     */
-    public SessionManager(String login, String password, String url) {
-	this.login = login;
-	this.password = password;
-	this.url = url + "/ws.php";
-	//	MultiThreadedHttpConnectionManager connectionManager = new MultiThreadedHttpConnectionManager();
-	//	client = new HttpClient(connectionManager);
-	ThreadSafeClientConnManager connectionManager = new ThreadSafeClientConnManager();
-	client = new DefaultHttpClient(connectionManager);
-	//Using of a Linux user agent. cause... it's better 8)
-	client.getParams().setParameter("http.useragent",
-		"Mozilla/5.0 (X11; U; Linux i686; fr; rv:1.9.1.1) Gecko/20090715 Firefox/3.5.1");
-
-    }
-
+public interface SessionManager {
     /**
      * Connection method
@@ -122,37 +16,5 @@
      *
      */
-    public int processLogin() {
-	Document doc;
-	//configures the proxy
-	if (usesProxy) {
-	    //	    HostConfiguration config = client.getHostConfiguration();
-	    //	    config.setProxy(urlProxy, portProxy);
-	    if (!StringUtils.isEmpty(loginProxy) && !StringUtils.isEmpty(passProxy)) {
-		//		Credentials credentials = new UsernamePasswordCredentials(loginProxy, passProxy);
-		//		AuthScope authScope = new AuthScope(urlProxy, portProxy);
-		//		client.getState().setProxyCredentials(authScope, credentials);
-		HttpHost proxy = new HttpHost(urlProxy, portProxy);
-		client.getParams().setParameter(ConnRoutePNames.DEFAULT_PROXY, proxy);
-		client.getCredentialsProvider().setCredentials(new AuthScope(urlProxy, portProxy),
-			new UsernamePasswordCredentials(loginProxy, passProxy));
-
-	    }
-	}
-	//	try {
-	try {
-	    doc = executeReturnDocument(MethodsEnum.LOGIN.getLabel(), "username", login, "password", password);
-	    return (Tools.checkOk(doc) ? 0 : 1);
-	} catch (IOException e) {
-	    LOG.debug(Tools.getStackTrace(e));
-	    return 1;
-	} catch (ProxyAuthenticationException e) {
-	    LOG.debug(Tools.getStackTrace(e));
-	    return 2;
-	} catch (Exception e) {
-	    LOG.debug(Tools.getStackTrace(e));
-	    return 1;
-	}
-
-    }
+    public int processLogin();
 
     /**
@@ -165,51 +27,5 @@
      */
     public String executeReturnString(String methode, String... parametres) throws UnsupportedEncodingException,
-	    ProxyAuthenticationException {
-	if (parametres.length % 2 != 0 && !(parametres == null)) {
-	    try {
-		throw new Exception("Le nombre de parametres doit etre pair");
-	    } catch (Exception e) {
-		LOG.error(Tools.getStackTrace(e));
-		return null;
-	    }
-	}
-	HttpPost method = new HttpPost(url);
-	List<NameValuePair> nameValuePairs = new ArrayList<NameValuePair>();
-	nameValuePairs.add(new BasicNameValuePair("method", methode));
-	for (int i = 0; i < parametres.length; i += 2) {
-	    nameValuePairs.add(new BasicNameValuePair(parametres[i], parametres[i + 1]));
-	}
-	method.setEntity(new UrlEncodedFormEntity(nameValuePairs));
-	//begin bug:0001833
-	method.setHeader("Content-Type", "application/x-www-form-urlencoded; charset=utf-8");
-	//end
-	try {
-	    HttpResponse response = client.execute(method);
-	    if (response.getStatusLine().getStatusCode() == 407) {
-		throw new ProxyAuthenticationException("Error while trying to auth on the proxy");
-	    }
-	    InputStream inputStream = response.getEntity().getContent();
-	    StringBuffer buffer = new StringBuffer();
-	    byte[] data = new byte[512];
-	    int len = 0;
-	    try {
-		while (-1 != (len = inputStream.read(data))) {
-		    buffer.append(new String(data, 0, len));
-		}
-	    } catch (IOException e) {
-		e.printStackTrace();
-	    }
-	    try {
-		inputStream.close();
-	    } catch (IOException e) {
-		e.printStackTrace();
-	    }
-	    return buffer.toString();
-	} catch (IOException e) {
-
-	}
-	return null;
-
-    }
+	    ProxyAuthenticationException;
 
     /**
@@ -222,15 +38,5 @@
      */
     public Document executeReturnDocument(String methode, String... parametres) throws IOException,
-	    ProxyAuthenticationException {
-	try {
-	    String returnedString = executeReturnString(methode, parametres);
-	    return Tools.stringToDocument(returnedString);
-	} catch (Exception e) {
-	    // TODO Auto-generated catch block
-	    LOG.error(Tools.getStackTrace(e));
-	}
-	return null;
-
-    }
+	    ProxyAuthenticationException;
 
     /**
@@ -240,93 +46,70 @@
      * @throws ProxyAuthenticationException
      */
-    public Document executeReturnDocument(String methode) throws ProxyAuthenticationException {
-	try {
-	    return Tools.stringToDocument(executeReturnString(methode));
-	} catch (Exception e) {
-	    // TODO Auto-generated catch block
-	    LOG.error(Tools.getStackTrace(e));
-	}
-	return null;
-
-    }
+    public Document executeReturnDocument(String methode) throws ProxyAuthenticationException;
 
     /**
+     * Getter of the login
      * @return the login
      */
-    public String getLogin() {
-	return login;
-    }
+    public String getLogin();
 
     /**
-     * @param login the login to set
+     * Setter of the login
+     * @param login
      */
-    public void setLogin(String login) {
-	this.login = login;
-    }
+    public void setLogin(String login);
 
     /**
-     * @return the url
+     * Setter of the user agent
+     * @param userAgent
      */
-    public String getUrl() {
-	return url;
-    }
+    public void setUserAgent(String userAgent);
 
     /**
-     * @param url the url to set
+     * Setter of the password to access piwigo
+     * @param password
      */
-    public void setUrl(String url) {
-	this.url = url;
-    }
+    public void setPassword(String password);
 
     /**
-     * @param usesProxy the usesProxy to set
+     * Setter of the proxy login
+     * @param loginProxy
      */
-    public void setUsesProxy(boolean usesProxy) {
-	this.usesProxy = usesProxy;
-    }
+    public void setLoginProxy(String loginProxy);
 
     /**
-     * @param urlProxy the urlProxy to set
+     * Setter of the proxy port
+     * @param port
      */
-    public void setUrlProxy(String urlProxy) {
-	this.urlProxy = urlProxy;
-    }
+    public void setPortProxy(int port);
 
     /**
-     * @param portProxy the portProxy to set
+     * Setter of the proxy url
+     * @param urlProxy
      */
-    public void setPortProxy(int portProxy) {
-	this.portProxy = portProxy;
-    }
+    public void setUrlProxy(String urlProxy);
 
     /**
-     * @param loginProxy the loginProxy to set
+     * Setter of the proxy pass
+     * @param proxyPass
      */
-    public void setLoginProxy(String loginProxy) {
-	this.loginProxy = loginProxy;
-    }
+    public void setPassProxy(String proxyPass);
 
     /**
-     * @param passProxy the passProxy to set
+     * Setter of the proxy url
+     * @param url
      */
-    public void setPassProxy(String passProxy) {
-	this.passProxy = passProxy;
-    }
+    public void setUrl(String url);
 
-    public String getPassword() {
-	return password;
-    }
+    /**
+     * Setter of the boolean that tells to use a proxy or not
+     * @param usesProxy
+     */
+    public void setUsesProxy(boolean usesProxy);
 
-    public void setPassword(String password) {
-	this.password = password;
-    }
-
-    public boolean isProxyError() {
-	return proxyError;
-    }
-
-    public void setProxyError(boolean proxyError) {
-	this.proxyError = proxyError;
-    }
-
+    /**
+     * Function that returns true if there is a proxy error
+     * @return
+     */
+    public boolean isProxyError();
 }
Index: extensions/jiwigo-ws-api/src/main/java/fr/mael/jiwigo/transverse/session/impl/SessionManagerImpl.java
===================================================================
--- extensions/jiwigo-ws-api/src/main/java/fr/mael/jiwigo/transverse/session/impl/SessionManagerImpl.java	(revision 9919)
+++ extensions/jiwigo-ws-api/src/main/java/fr/mael/jiwigo/transverse/session/impl/SessionManagerImpl.java	(revision 9919)
@@ -0,0 +1,329 @@
+package fr.mael.jiwigo.transverse.session.impl;
+
+import java.io.IOException;
+import java.io.InputStream;
+import java.io.UnsupportedEncodingException;
+import java.util.ArrayList;
+import java.util.List;
+
+import org.apache.commons.lang.StringUtils;
+import org.apache.http.HttpHost;
+import org.apache.http.HttpResponse;
+import org.apache.http.NameValuePair;
+import org.apache.http.auth.AuthScope;
+import org.apache.http.auth.UsernamePasswordCredentials;
+import org.apache.http.client.entity.UrlEncodedFormEntity;
+import org.apache.http.client.methods.HttpPost;
+import org.apache.http.conn.params.ConnRoutePNames;
+import org.apache.http.impl.client.DefaultHttpClient;
+import org.apache.http.message.BasicNameValuePair;
+import org.slf4j.Logger;
+import org.slf4j.LoggerFactory;
+import org.w3c.dom.Document;
+
+import fr.mael.jiwigo.transverse.enumeration.MethodsEnum;
+import fr.mael.jiwigo.transverse.exception.ProxyAuthenticationException;
+import fr.mael.jiwigo.transverse.session.SessionManager;
+import fr.mael.jiwigo.transverse.util.Tools;
+
+/*
+ *  jiwigo-ws-api Piwigo webservice access Api
+ *  Copyright (c) 2010-2011 Mael mael@le-guevel.com
+ *                All Rights Reserved
+ *
+ *  This library is free software. It comes without any warranty, to
+ *  the extent permitted by applicable law. You can redistribute it
+ *  and/or modify it under the terms of the Do What The Fuck You Want
+ *  To Public License, Version 2, as published by Sam Hocevar. See
+ *  http://sam.zoy.org/wtfpl/COPYING for more details.
+ */
+/**
+
+ * @author mael
+ * Gestionnaire de connexion
+ */
+public class SessionManagerImpl implements SessionManager {
+
+    /**
+     * Logger
+     */
+    private final Logger LOG = LoggerFactory.getLogger(SessionManagerImpl.class);
+    /**
+     * the entered login
+     */
+    private String login;
+    /**
+     * the entered password
+     */
+    private String password;
+    /**
+     * the url of the site
+     */
+    private String url;
+    /**
+     * the http client
+     */
+    private DefaultHttpClient client;
+
+    /**
+     * defines if the user uses a proxy
+     */
+    private boolean usesProxy;
+
+    /**
+     * url of the proxy
+     */
+    private String urlProxy;
+
+    /**
+     * port of the proxy
+     */
+    private int portProxy;
+
+    /**
+     * login for the proxy
+     */
+    private String loginProxy;
+
+    /**
+     * pass for the proxy
+     */
+    private String passProxy;
+
+    /**
+     * true : an error was found for the proxy
+     */
+    private boolean proxyError;
+
+    public SessionManagerImpl() {
+	client = new DefaultHttpClient();
+    }
+
+    /**
+     * Constructor
+     * @param login the login
+     * @param password the password
+     * @param url the url of the site
+     * @param userAgent the user agent to use
+     */
+    public SessionManagerImpl(String login, String password, String url, String userAgent) {
+	this.login = login;
+	this.password = password;
+	this.url = url + "/ws.php";
+	//	MultiThreadedHttpConnectionManager connectionManager = new MultiThreadedHttpConnectionManager();
+	//	client = new HttpClient(connectionManager);
+	//	ThreadSafeClientConnManager connectionManager = new ThreadSafeClientConnManager(null, null);
+	client = new DefaultHttpClient();
+	//Using of a Linux user agent. cause... it's better 8)
+	client.getParams().setParameter("http.useragent", userAgent);
+
+    }
+
+    /**
+     * Fonction used to set the user agent of the http client
+     * @param userAgent
+     */
+    public void setUserAgent(String userAgent) {
+	client.getParams().setParameter("http.useragent", userAgent);
+    }
+
+    /**
+     * Connection method
+     *
+     * @return 0 if Ok, 1 if not Ok (reason not specified), 2 if proxy error
+     *
+     *
+     */
+    public int processLogin() {
+	Document doc;
+	//configures the proxy
+	if (usesProxy) {
+	    //	    HostConfiguration config = client.getHostConfiguration();
+	    //	    config.setProxy(urlProxy, portProxy);
+	    if (!StringUtils.isEmpty(loginProxy) && !StringUtils.isEmpty(passProxy)) {
+		//		Credentials credentials = new UsernamePasswordCredentials(loginProxy, passProxy);
+		//		AuthScope authScope = new AuthScope(urlProxy, portProxy);
+		//		client.getState().setProxyCredentials(authScope, credentials);
+		HttpHost proxy = new HttpHost(urlProxy, portProxy);
+		client.getParams().setParameter(ConnRoutePNames.DEFAULT_PROXY, proxy);
+		client.getCredentialsProvider().setCredentials(new AuthScope(urlProxy, portProxy),
+			new UsernamePasswordCredentials(loginProxy, passProxy));
+
+	    }
+	}
+	//	try {
+	try {
+	    doc = executeReturnDocument(MethodsEnum.LOGIN.getLabel(), "username", login, "password", password);
+	    return (Tools.checkOk(doc) ? 0 : 1);
+	} catch (IOException e) {
+	    LOG.debug(Tools.getStackTrace(e));
+	    return 1;
+	} catch (ProxyAuthenticationException e) {
+	    LOG.debug(Tools.getStackTrace(e));
+	    return 2;
+	} catch (Exception e) {
+	    LOG.debug(Tools.getStackTrace(e));
+	    return 1;
+	}
+
+    }
+
+    /**
+     * Executes a method on the webservice and returns the result as a string
+     * @param methode the method to execute
+     * @param parametres the parameters of the method. Must be even : the name of the parameter followed by its value
+     * @return the result
+     * @throws UnsupportedEncodingException
+     * @throws ProxyAuthenticationException
+     */
+    public String executeReturnString(String methode, String... parametres) throws UnsupportedEncodingException,
+	    ProxyAuthenticationException {
+	if (parametres.length % 2 != 0 && !(parametres == null)) {
+	    try {
+		throw new Exception("Le nombre de parametres doit etre pair");
+	    } catch (Exception e) {
+		LOG.error(Tools.getStackTrace(e));
+		return null;
+	    }
+	}
+	HttpPost method = new HttpPost(url);
+	List<NameValuePair> nameValuePairs = new ArrayList<NameValuePair>();
+	nameValuePairs.add(new BasicNameValuePair("method", methode));
+	for (int i = 0; i < parametres.length; i += 2) {
+	    nameValuePairs.add(new BasicNameValuePair(parametres[i], parametres[i + 1]));
+	}
+	method.setEntity(new UrlEncodedFormEntity(nameValuePairs));
+	method.setHeader("Content-Type", "application/x-www-form-urlencoded; charset=utf-8");
+	try {
+	    HttpResponse response = client.execute(method);
+	    if (response.getStatusLine().getStatusCode() == 407) {
+		throw new ProxyAuthenticationException("Error while trying to auth on the proxy");
+	    }
+	    InputStream inputStream = response.getEntity().getContent();
+	    String toReturn = Tools.readInputStreamAsString(inputStream);
+	    return toReturn;
+	} catch (IOException e) {
+
+	}
+	return null;
+
+    }
+
+    /**
+     * Executes a method on the webservice and returns the result as a Dom document
+     * @param methode the method to execute
+     * @param parametres the parameters of the method. Must be even : the name of the parameter followed by its value
+     * @return the result
+     * @throws IOException
+     * @throws ProxyAuthenticationException
+     */
+    public Document executeReturnDocument(String methode, String... parametres) throws IOException,
+	    ProxyAuthenticationException {
+	try {
+	    String returnedString = executeReturnString(methode, parametres);
+	    return Tools.stringToDocument(returnedString);
+	} catch (Exception e) {
+	    // TODO Auto-generated catch block
+	    LOG.error(Tools.getStackTrace(e));
+	}
+	return null;
+
+    }
+
+    /**
+     * Executes a method on the webservice and returns the result as a Dom document
+     * @param methode the method to execute
+     * @return the result
+     * @throws ProxyAuthenticationException
+     */
+    public Document executeReturnDocument(String methode) throws ProxyAuthenticationException {
+	try {
+	    return Tools.stringToDocument(executeReturnString(methode));
+	} catch (Exception e) {
+	    // TODO Auto-generated catch block
+	    LOG.error(Tools.getStackTrace(e));
+	}
+	return null;
+
+    }
+
+    /**
+     * @return the login
+     */
+    public String getLogin() {
+	return login;
+    }
+
+    /**
+     * @param login the login to set
+     */
+    public void setLogin(String login) {
+	this.login = login;
+    }
+
+    /**
+     * @return the url
+     */
+    public String getUrl() {
+	return url;
+    }
+
+    /**
+     * @param url the url to set
+     */
+    public void setUrl(String url) {
+	this.url = url;
+    }
+
+    /**
+     * @param usesProxy the usesProxy to set
+     */
+    public void setUsesProxy(boolean usesProxy) {
+	this.usesProxy = usesProxy;
+    }
+
+    /**
+     * @param urlProxy the urlProxy to set
+     */
+    public void setUrlProxy(String urlProxy) {
+	this.urlProxy = urlProxy;
+    }
+
+    /**
+     * @param portProxy the portProxy to set
+     */
+    public void setPortProxy(int portProxy) {
+	this.portProxy = portProxy;
+    }
+
+    /**
+     * @param loginProxy the loginProxy to set
+     */
+    public void setLoginProxy(String loginProxy) {
+	this.loginProxy = loginProxy;
+    }
+
+    /**
+     * @param passProxy the passProxy to set
+     */
+    public void setPassProxy(String passProxy) {
+	this.passProxy = passProxy;
+    }
+
+    public String getPassword() {
+	return password;
+    }
+
+    public void setPassword(String password) {
+	this.password = password;
+    }
+
+    public boolean isProxyError() {
+	return proxyError;
+    }
+
+    public void setProxyError(boolean proxyError) {
+	this.proxyError = proxyError;
+    }
+
+}
Index: extensions/jiwigo-ws-api/src/main/java/fr/mael/jiwigo/transverse/util/Tools.java
===================================================================
--- extensions/jiwigo-ws-api/src/main/java/fr/mael/jiwigo/transverse/util/Tools.java	(revision 9902)
+++ extensions/jiwigo-ws-api/src/main/java/fr/mael/jiwigo/transverse/util/Tools.java	(revision 9919)
@@ -40,4 +40,6 @@
 import org.apache.sanselan.formats.jpeg.iptc.PhotoshopApp13Data;
 import org.apache.sanselan.formats.tiff.write.TiffOutputSet;
+import org.slf4j.Logger;
+import org.slf4j.LoggerFactory;
 import org.w3c.dom.Document;
 import org.w3c.dom.Element;
@@ -46,4 +48,5 @@
 import org.xml.sax.SAXException;
 
+import fr.mael.jiwigo.service.impl.CategoryServiceImpl;
 import fr.mael.jiwigo.transverse.exception.FileAlreadyExistsException;
 
@@ -68,5 +71,5 @@
      * Logger
      */
-    public static final org.apache.commons.logging.Log LOG = org.apache.commons.logging.LogFactory.getLog(Tools.class);
+    private static final Logger LOG = LoggerFactory.getLogger(CategoryServiceImpl.class);
 
     /**
@@ -97,4 +100,5 @@
     public static Document stringToDocument(String xmlSource) throws SAXException, ParserConfigurationException,
 	    IOException {
+	LOG.debug(xmlSource);
 	DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
 	DocumentBuilder builder = factory.newDocumentBuilder();
@@ -327,7 +331,55 @@
     }
 
+    public static Document readFileAsDocument(String filePath) {
+	Document doc = null;
+	try {
+	    DocumentBuilderFactory dbfac = DocumentBuilderFactory.newInstance();
+	    DocumentBuilder docBuilder = dbfac.newDocumentBuilder();
+	    doc = docBuilder.parse(filePath);
+	} catch (Exception e) {
+	    LOG.error("Error converting file to Document : " + getStackTrace(e));
+	}
+	return doc;
+    }
+
+    /**
+     * Gets the value of a document node
+     * @param element
+     * @param tagName
+     * @return
+     */
     public static String getStringValueDom(Element element, String tagName) {
 	Element el = (Element) element.getElementsByTagName(tagName).item(0);
 	return el.getFirstChild().getNodeValue();
     }
+
+    /**
+     * Sets the value of a document node
+     * @param element
+     * @param tagName
+     * @param value
+     */
+    public static void setStringValueDom(Element element, String tagName, String value) {
+	Element el = (Element) element.getElementsByTagName(tagName).item(0);
+	el.setNodeValue(value);
+    }
+
+    /**
+     * Write an xml document to a file
+     * @param doc document to write
+     * @param filename file where to write the document
+     */
+    public static void writeXmlFile(Document doc, String filename) {
+	try {
+	    Source source = new DOMSource(doc);
+	    File file = new File(filename);
+	    Result result = new StreamResult(file);
+	    Transformer xformer = TransformerFactory.newInstance().newTransformer();
+	    xformer.transform(source, result);
+	} catch (TransformerConfigurationException e) {
+	    LOG.error(getStackTrace(e));
+	} catch (TransformerException e) {
+	    LOG.error(getStackTrace(e));
+	}
+    }
 }
